Description: fix ssl_wrap removed from ssl.py
Author: Rene Luria <rene.luria@infomaniak.com>
Bug-Debian: https://bugs.debian.org/1058269
Forwarded: no
Last-Update: 2023-12-19

diff --git a/pylxd/deprecated/connection.py b/pylxd/deprecated/connection.py
index 97db0f1..a391a51 100644
--- a/pylxd/deprecated/connection.py
+++ b/pylxd/deprecated/connection.py
@@ -78,9 +78,10 @@ class HTTPSConnection(http_client.HTTPConnection):
             self._tunnel()
 
         (cert_file, key_file) = self._get_ssl_certs()
-        self.sock = ssl.wrap_socket(sock, certfile=cert_file,
-                                    keyfile=key_file,
-                                    ssl_version=DEFAULT_TLS_VERSION)
+        context = ssl.SSLContext(DEFAULT_TLS_VERSION)
+        if cert_file and os.path.exists(cert_file):
+            context.load_cert_chain(certfile=cert_file, keyfile=key_file)
+        self.sock = context.wrap_socket(sock)
 
     @staticmethod
     def _get_ssl_certs():
diff --git a/pylxd/deprecated/tests/test_connection.py b/pylxd/deprecated/tests/test_connection.py
index 30f8d2e..cf06633 100644
--- a/pylxd/deprecated/tests/test_connection.py
+++ b/pylxd/deprecated/tests/test_connection.py
@@ -47,7 +47,7 @@ class LXDInitConnectionTest(unittest.TestCase):
         ms.return_value.connect.assert_called_once_with('/')
 
     @mock.patch('os.environ', {'HOME': '/home/foo'})
-    @mock.patch('ssl.wrap_socket')
+    @mock.patch('ssl.SSLContext.wrap_socket')
     @mock.patch('socket.create_connection')
     def test_https_connection(self, ms, ml):
         conn = connection.HTTPSConnection('host', 1234)
@@ -58,13 +58,10 @@ class LXDInitConnectionTest(unittest.TestCase):
                 ('host', 1234), socket._GLOBAL_DEFAULT_TIMEOUT, None)
             ml.assert_called_once_with(
                 ms.return_value,
-                certfile='/home/foo/.config/lxc/client.crt',
-                keyfile='/home/foo/.config/lxc/client.key',
-                ssl_version=connection.DEFAULT_TLS_VERSION,
             )
 
     @mock.patch('os.environ', {'HOME': '/home/foo'})
-    @mock.patch('ssl.wrap_socket')
+    @mock.patch('ssl.SSLContext.wrap_socket')
     @mock.patch('socket.create_connection')
     def test_https_proxy_connection(self, ms, ml):
         conn = connection.HTTPSConnection('host', 1234)
@@ -76,9 +73,7 @@ class LXDInitConnectionTest(unittest.TestCase):
                 ('host', 1234), socket._GLOBAL_DEFAULT_TIMEOUT, None)
             ml.assert_called_once_with(
                 ms.return_value,
-                certfile='/home/foo/.config/lxc/client.crt',
-                keyfile='/home/foo/.config/lxc/client.key',
-                ssl_version=connection.DEFAULT_TLS_VERSION)
+            )
 
     @mock.patch('pylxd.deprecated.connection.HTTPSConnection')
     @mock.patch('pylxd.deprecated.connection.UnixHTTPConnection')
